## @file
# Define Global Variables

package esas_GVariables;

##################################################
## the object constructor (simplistic version)  ##
##################################################
sub new {
    my $self  = {};    
    $self->{Cheese_prefixm}         = [];
    $self->{Cheese_prefixp}         = [];
    $self->{Cheese_verb}            = undef;
    $self->{Cheese_scale}           = undef;
    $self->{Cheese_rate}            = undef;
    $self->{Cheese_dist}            = undef; 
    $self->{Cheese_clobber}         = undef;
    $self->{Cheese_elow}            = undef;
    $self->{Cheese_ehigh}           = undef;
   
    $self->{Cheesebands_prefixm}    = [];
    $self->{Cheesebands_prefixp}    = [];
    $self->{Cheesebands_verb}       = undef;
    $self->{Cheesebands_scale}      = undef;
    $self->{Cheesebands_ratet}      = undef;
    $self->{Cheesebands_rates}      = undef;
    $self->{Cheesebands_rateh}      = undef;
    $self->{Cheesebands_dist}       = undef; 
    $self->{Cheesebands_clobber}    = undef;
    $self->{Cheesebands_elowlist}   = [];
    $self->{Cheesebands_ehighlist}  = [];
   
    $self->{ConvRegion_obsidlist}   = [];
    $self->{ConvRegion_targfile}    = [];
   
    $self->{MOSSpectra_prefix}  	= undef;
    $self->{MOSSpectra_region}		= undef;
    $self->{MOSSpectra_mask} 		= undef;
    $self->{MOSSpectra_elow}		= undef;
    $self->{MOSSpectra_ehigh} 		= undef;
    $self->{MOSSpectra_CCD1} 		= undef;
    $self->{MOSSpectra_CCD2} 		= undef;
    $self->{MOSSpectra_CCD3} 		= undef;
    $self->{MOSSpectra_CCD4} 		= undef;
    $self->{MOSSpectra_CCD5} 		= undef;
    $self->{MOSSpectra_CCD6} 		= undef;
    $self->{MOSSpectra_CCD7} 		= undef;
   
    $self->{PNSpectra_prefix} 	 	= undef;
    $self->{PNSpectra_caldb} 	 	= undef;
    $self->{PNSpectra_region}		= undef;
    $self->{PNSpectra_mask} 		= undef;
    $self->{PNSpectra_elow}		= undef;
    $self->{PNSpectra_ehigh} 		= undef;
#    $self->{PNSpectra_pattern} 		= undef;
    $self->{PNSpectra_QUAD1} 		= undef;
    $self->{PNSpectra_QUAD2} 		= undef;
    $self->{PNSpectra_QUAD3} 		= undef;
    $self->{PNSpectra_QUAD4} 		= undef;
        
    $self->{ROTIM_prefix}		= undef;
    $self->{ROTIM_elow}			= undef;
    $self->{ROTIM_ehigh}		= undef;
    $self->{ROTIM_mode}			= undef; 
    $self->{ROTIM_mask}			= undef;
     
    bless($self);          
    return $self;
}

sub printConvReg {
	 my $self = shift;
	 print "obsidlist = $self->{ConvRegion_obsidlist}";
	 print "targfile = $self->{ConvRegion_targfile}";
}

sub printROTIM {
	 my $self = shift;
	 print "prefix = $self->{ROTIM_prefix}";
	 print "elow = $self->{ROTIM_elow}";
	 print "ehigh = $self->{ROTIM_ehigh}";
	 print "mode = $self->{ROTIM_mode}";
	 print "mask = $self->{ROTIM_mask}";
}

sub printCheese {
    my $self = shift;
 
 	@tmp = $self->{Cheese_prefixm};
 	print "mosExp = $tmp\n";
 	@tmp = $self->{Cheese_prefixp};
 	print "pnExp = $tmp\n";
	print "verb = $self->{Cheese_verb}\n";
	print "scale = $self->{Cheese_scale}\n";
	print "rate = $self->{Cheese_rate}\n";
	print "dist = $self->{Cheese_dist}\n";
	print "clobber = $self->{Cheese_clobber}\n";
	print "elow = $self->{Cheese_elow}\n";
	print "ehigh = $self->{Cheese_ehigh}\n";
	

	print "---> esas variables <----\n";
}

sub printCheesebands {
    my $self = shift;
 
 	@tmp = $self->{Cheesebands_prefixm};
 	print "mosExp = $tmp\n";
 	@tmp = $self->{Cheesebands_prefixp};
 	print "pnExp = $tmp\n";
	print "verb = $self->{Cheesebands_verb}\n";
	print "scale = $self->{Cheesebands_scale}\n";
	print "ratet = $self->{Cheesebands_ratet}\n";
	print "rates = $self->{Cheesebands_rates}\n";
	print "rateh = $self->{Cheesebands_rateh}\n";
	print "dist = $self->{Cheesebands_dist}\n";
	print "clobber = $self->{Cheesebands_clobber}\n";
 	@tmp = $self->{Cheesebands_elowlist};
 	print "elowlist = $tmp\n";
#	print "elowlist = $self->{Cheesebands_elowlist}\n";
 	@tmp = $self->{Cheesebands_ehighlist};
 	print "ehighlist = $tmp\n";
#	print "ehighlist = $self->{Cheesebands_ehighlist}\n";
	
	print "---> esas variables <----\n";
}

sub printMOSSpectra {
	my $self = shift;
	
	print "MOS prefix = $self->{MOSSpectra_prefix}\n";
	print " = $self->{MOSSpectra_region}\n";
	print " = $self->{MOSSpectra_mask}\n";
	print " = $self->{MOSSpectra_elow}\n";
	print " = $self->{MOSSpectra_ehigh}\n";
	print " = $self->{MOSSpectra_CCD1}\n";
	print " = $self->{MOSSpectra_CCD2}\n";
	print " = $self->{MOSSpectra_CCD3}\n";
	print " = $self->{MOSSpectra_CCD4}\n";
	print " = $self->{MOSSpectra_CCD5}\n";
	print " = $self->{MOSSpectra_CCD6}\n";
	print " = $self->{MOSSpectra_CCD7}\n";
	print " = $self->{MOSSpectra_caldb}\n";
	
}

sub printPNSpectra {
	my $self = shift;
	
	print "PN prefix = $self->{PNSpectra_prefix}\n";
	print " = $self->{PNSpectra_caldb}\n";
	print " = $self->{PNSpectra_region}\n";
	print " = $self->{PNSpectra_mask}\n";
	print " = $self->{PNSpectra_elow}\n";
	print " = $self->{PNSpectra_ehigh}\n";
#	print " = $self->{PNSpectra_pattern}\n";
	print " = $self->{PNSpectra_CCD1}\n";
	print " = $self->{PNSpectra_CCD2}\n";
	print " = $self->{PNSpectra_CCD3}\n";
	print " = $self->{PNSpectra_CCD4}\n";
#	print " = $self->{PNSpectra_caldb}\n";
	
}

##############################################
## methods to access per-object data        ##
##                                          ##
## With args, they set the value.  Without  ##
## any, they only retrieve it/them.         ## 
##############################################

sub ConvRegion_obsidlist {
    my $self = shift;
    if (@_) { $self->{ConvRegion_obsidlist}  = shift }
    return $self->{ConvRegion_obsidlist};
}

sub ConvRegion_targfile {
    my $self = shift;
    if (@_) { $self->{ConvRegion_targfile}  = shift }
    return $self->{ConvRegion_targfile};
}

sub ROTIM_prefix {
    my $self = shift;
    if (@_) { $self->{ROTIM_prefix}  = shift }
    return $self->{ROTIM_prefix};
}

sub ROTIM_elow {
    my $self = shift;
    if (@_) { $self->{ROTIM_elow}  = shift }
    return $self->{ROTIM_elow};
}

sub ROTIM_ehigh {
    my $self = shift;
    if (@_) { $self->{ROTIM_ehigh}  = shift }
    return $self->{ROTIM_ehigh};
}

sub ROTIM_mode {
    my $self = shift;
    if (@_) { $self->{ROTIM_mode}  = shift }
    return $self->{ROTIM_mode};
}

sub ROTIM_mask {
    my $self = shift;
    if (@_) { $self->{ROTIM_mask}  = shift }
    return $self->{ROTIM_mask};
}


sub MOSSpectra_prefix {
    my $self = shift;
    if (@_) { $self->{MOSSpectra_prefix}  = shift }
    return $self->{MOSSpectra_prefix};
}

sub MOSSpectra_region {
    my $self = shift;
    if (@_) { $self->{MOSSpectra_region}  = shift }
    return $self->{MOSSpectra_region};
}

sub MOSSpectra_mask {
    my $self = shift;
    if (@_) { $self->{MOSSpectra_mask}  = shift }
    return $self->{MOSSpectra_mask};
}

sub MOSSpectra_elow {
    my $self = shift;
    if (@_) { $self->{MOSSpectra_elow}  = shift }
    return $self->{MOSSpectra_elow};
}

sub MOSSpectra_ehigh {
    my $self = shift;
    if (@_) { $self->{MOSSpectra_ehigh}  = shift }
    return $self->{MOSSpectra_ehigh};
}
sub MOSSpectra_CCD1 {
    my $self = shift;
    if (@_) { $self->{MOSSpectra_CCD1}  = shift }
    return $self->{MOSSpectra_CCD1};
}
sub MOSSpectra_CCD2 {
    my $self = shift;
    if (@_) { $self->{MOSSpectra_CCD2}  = shift }
    return $self->{MOSSpectra_CCD2};
}
sub MOSSpectra_CCD3 {
    my $self = shift;
    if (@_) { $self->{MOSSpectra_CCD3}  = shift }
    return $self->{MOSSpectra_CCD3};
}

sub MOSSpectra_CCD4 {
    my $self = shift;
    if (@_) { $self->{MOSSpectra_CCD4}  = shift }
    return $self->{MOSSpectra_CCD4};
}

sub MOSSpectra_CCD5 {
    my $self = shift;
    if (@_) { $self->{MOSSpectra_CCD5}  = shift }
    return $self->{MOSSpectra_CCD5};
}

sub MOSSpectra_CCD6 {
    my $self = shift;
    if (@_) { $self->{MOSSpectra_CCD6}  = shift }
    return $self->{MOSSpectra_CCD6};
}

sub MOSSpectra_CCD7 {
    my $self = shift;
    if (@_) { $self->{MOSSpectra_CCD7}  = shift }
    return $self->{MOSSpectra_CCD7};
}

sub MOSSpectra_caldb {
    my $self = shift;
    if (@_) { $self->{MOSSpectra_caldb}  = shift }
    return $self->{MOSSpectra_caldb};
}

sub PNSpectra_prefix {
    my $self = shift;
    if (@_) { $self->{PNSpectra_prefix}  = shift }
    return $self->{PNSpectra_prefix};
}

sub PNSpectra_caldb {
    my $self = shift;
    if (@_) { $self->{PNSpectra_caldb}  = shift }
    return $self->{PNSpectra_caldb};
}

sub PNSpectra_region {
    my $self = shift;
    if (@_) { $self->{PNSpectra_region}  = shift }
    return $self->{PNSpectra_region};
}

sub PNSpectra_mask {
    my $self = shift;
    if (@_) { $self->{PNSpectra_mask}  = shift }
    return $self->{PNSpectra_mask};
}

sub PNSpectra_elow {
    my $self = shift;
    if (@_) { $self->{PNSpectra_elow}  = shift }
    return $self->{PNSpectra_elow};
}

sub PNSpectra_ehigh {
    my $self = shift;
    if (@_) { $self->{PNSpectra_ehigh}  = shift }
    return $self->{PNSpectra_ehigh};
}

#sub PNSpectra_pattern {
#    my $self = shift;
#    if (@_) { $self->{PNSpectra_pattern}  = shift }
#    return $self->{PNSpectra_pattern};
#}

sub PNSpectra_QUAD1 {
    my $self = shift;
    if (@_) { $self->{PNSpectra_QUAD1}  = shift }
    return $self->{PNSpectra_QUAD1};
}
sub PNSpectra_QUAD2 {
    my $self = shift;
    if (@_) { $self->{PNSpectra_QUAD2}  = shift }
    return $self->{PNSpectra_QUAD2};
}
sub PNSpectra_QUAD3 {
    my $self = shift;
    if (@_) { $self->{PNSpectra_QUAD3}  = shift }
    return $self->{PNSpectra_QUAD3};
}
sub PNSpectra_QUAD4 {
    my $self = shift;
    if (@_) { $self->{PNSpectra_QUAD4}  = shift }
    return $self->{PNSpectra_QUAD4};
}

sub Cheese_prefixm {
    my $self = shift;
    if (@_) { @{ $self->{Cheese_prefixm} } = @_ }
    return @{ $self->{Cheese_prefixm} };
}

sub Cheese_prefixp {
    my $self = shift;
    if (@_) { @{ $self->{Cheese_prefixp} } = @_ }
    return @{ $self->{Cheese_prefixp} };
}

sub Cheese_verb {
    my $self = shift;
    if (@_) { $self->{Cheese_verb}  = shift }
    return $self->{Cheese_verb};
}

sub Cheese_scale {
    my $self = shift;
    if (@_) { $self->{Cheese_scale}  = shift }
    return $self->{Cheese_scale};
}
sub Cheese_rate {
    my $self = shift;
    if (@_) { $self->{Cheese_rate}  = shift }
    return $self->{Cheese_rate};
}
sub Cheese_dist {
    my $self = shift;
    if (@_) { $self->{Cheese_dist}  = shift }
    return $self->{Cheese_dist};
}
sub Cheese_clobber {
    my $self = shift;
    if (@_) { $self->{Cheese_clobber}  = shift }
    return $self->{Cheese_clobber};
}

sub Cheese_elow {
    my $self = shift;
    if (@_) { $self->{Cheese_elow}  = shift }
    return $self->{Cheese_elow};
}

sub Cheese_ehigh {
    my $self = shift;
    if (@_) { $self->{Cheese_ehigh}  = shift }
    return $self->{Cheese_ehigh};
}		

sub Cheesebands_prefixm {
    my $self = shift;
    if (@_) { @{ $self->{Cheesebands_prefixm} } = @_ }
    return @{ $self->{Cheesebands_prefixm} };
}

sub Cheesebands_prefixp {
    my $self = shift;
    if (@_) { @{ $self->{Cheesebands_prefixp} } = @_ }
    return @{ $self->{Cheesebands_prefixp} };
}

sub Cheesebands_verb {
    my $self = shift;
    if (@_) { $self->{Cheesebands_verb}  = shift }
    return $self->{Cheesebands_verb};
}

sub Cheesebands_scale {
    my $self = shift;
    if (@_) { $self->{Cheesebands_scale}  = shift }
    return $self->{Cheesebands_scale};
}
sub Cheesebands_ratet {
    my $self = shift;
    if (@_) { $self->{Cheesebands_ratet}  = shift }
    return $self->{Cheesebands_ratet};
}
sub Cheesebands_rates {
    my $self = shift;
    if (@_) { $self->{Cheesebands_rates}  = shift }
    return $self->{Cheesebands_rates};
}
sub Cheesebands_rateh {
    my $self = shift;
    if (@_) { $self->{Cheesebands_rateh}  = shift }
    return $self->{Cheesebands_rateh};
}
sub Cheesebands_dist {
    my $self = shift;
    if (@_) { $self->{Cheesebands_dist}  = shift }
    return $self->{Cheesebands_dist};
}
sub Cheesebands_clobber {
    my $self = shift;
    if (@_) { $self->{Cheesebands_clobber}  = shift }
    return $self->{Cheesebands_clobber};
}

sub Cheesebands_elowlist {
    my $self = shift;
    if (@_) { @{ $self->{Cheesebands_elowlist} } = @_ }
    return @{ $self->{Cheesebands_elowlist} };
}

#sub Cheesebands_elowlist {
#    my $self = shift;
#    if (@_) { $self->{Cheesebands_elowlist}  = shift }
#    return $self->{Cheesebands_elowlist};
#}

sub Cheesebands_ehighlist {
    my $self = shift;
    if (@_) { @{ $self->{Cheesebands_ehighlist} } = @_ }
    return @{ $self->{Cheesebands_ehighlist} };
}

#sub Cheesebands_ehighlist {
#    my $self = shift;
#    if (@_) { $self->{Cheesebands_ehighlist}  = shift }
#    return $self->{Cheesebands_ehighlist};
#}		

1;
