!+
! Module: bin_image_merge_mod
!
! Authors:  Steven L. Snowden - Goddard Space Flight Center (NASA)
!
! Description: Extended Source Analysis Software
!
! Comments:
!
! $Id: bin_image_merge_mod.f90,v 1.0 2010/03/11 snowden Exp $
!-
module bin_image_merge_mod

  use dal
  use param
  use errorHandling

  implicit none

  private

  public bin_image_merge

contains

  !---------------------------------------------------------------------
  subroutine bin_image_merge
  !---------------------------------------------------------------------

    real :: TEMSC
    integer, dimension(:), allocatable :: IEL, IEH
    integer :: i, nb, IBIN
	logical :: ipart, isoft, iswcx
        character(len=132) :: INFILE

    TEMSC = realParameter("thresholdmasking")
    nb = intParameter("nbands")

    allocate(IEL(nb),IEH(nb))
    do i=1, parameterCount("elowlist")
      IEL(i) = intParameter("elowlist",i-1)
      IEH(i) = intParameter("ehighlist",i-1)
    end do

    IBIN = intParameter("binning")
    IPART = booleanParameter("withpartcontrol")
    ISOFT = booleanParameter("withsoftcontrol")
    ISWCX = booleanParameter("withswcxcontrol")

    INFILE = stringParameter("maskfile")

    call bin_image_merge_sub(TEMSC,nb,IEL,IEH,IBIN,IPART,ISOFT,ISWCX,INFILE)

    deallocate(IEL,IEH)
  end subroutine bin_image_merge

end module bin_image_merge_mod
