!+
! Module: bin_image_mod
!
! Authors:  Steven L. Snowden - Goddard Space Flight Center (NASA)
!
! Description: Extended Source Analysis Software
!
! Comments:
!
! $Id: bin_image_mod.f90,v 1.2 2009/02/20 13:27:08 aibarra Exp $
!-
module bin_image_mod

  use dal
  use param
  use errorHandling

  implicit none

  private

  public bin_image

contains

  !---------------------------------------------------------------------
  subroutine bin_image
  !---------------------------------------------------------------------
    real ::  TEMSC
    integer :: IDET, IBIN,IEL,IEH
    logical :: IPART, IPROT, ISWCX
    character (len=5) :: PREFIX
    character (len=132) :: MASKFILE

    TEMSC = realParameter("thresholdmasking")
    IDET = intParameter("detector")
    IBIN = intParameter("binning")
    IEL = intParameter("elow")
    IEH = intParameter("ehigh")
    IPART = booleanParameter("withpartcontrol")
    IPROT = booleanParameter("withsoftcontrol")
    ISWCX = booleanParameter("withswcxcontrol")
    PREFIX = stringParameter("prefix")
    MASKFILE = stringParameter("maskfile")

    call bin_image_sub(TEMSC,IDET,PREFIX,PREFIX,IBIN,IEL,IEH,IPART,IPROT,ISWCX,MASKFILE)


  end subroutine bin_image

end module bin_image_mod
