!+
! Module: esprep_mosaic_mod
!
! Authors:  Steven L. Snowden - Goddard Space Flight Center (NASA)
!
! Description: Extended Source Analysis Software
!
! Comments:
!
! $Id: esprep_mosaic_mod.f90,v 1.2 2012/03/25 13:27:08 Snowden Exp $
!-
module esprep_mosaic_mod

  use dal
  use param
  use errorHandling

  implicit none

  private

  public esprep_mosaic

contains

  !---------------------------------------------------------------------
  subroutine esprep_mosaic
  !---------------------------------------------------------------------
   character (len=80) :: EVENTSIN, EVENTSOUT
   integer :: clobber
   real :: decobj, pa, raobj

   EVENTSIN = stringParameter("eventsin")
   EVENTSOUT = stringParameter("eventsout")
   RAOBJ = realParameter("raobj")
   DECOBJ = realParameter("decobj")
   PA = realParameter("pa")
   CLOBBER = intParameter("clobber")

   call esprep_mosaic_sub(eventsin,eventsout,raobj,decobj,pa,clobber)

  end subroutine esprep_mosaic

end module esprep_mosaic_mod
