        subroutine esprep_mosaic_sub(eventsin,eventsout,raobj,decobj,
     +          pas,clobber)
c
        implicit none
        integer block, blockin, clobber, err, hdutypein, 
     +      hdutypeout, i, icol, idum, ix, ixmax, ixmin, 
     +      ixtin, ixtout, iy, iymax, iymin, iytin, iytout,  
     +      lunin, lunout, nchan, ncols, 
     +      status, tfields, varidat
        real decobj, pas, raobj
        double precision dec, dect, dum, dxpix, dypix, pa, ra, 
     +      rat, rot, x, xinc, xmax, xmin, xpix, xrpix, xrval, 
     +      y, yinc, ymax, ymin, ypix, yrpix, yrval
        character*4 coord
        character*8 colnam(12), tform(12), ttype(12), tunit(12)
        character*20 extname
        character*80 com, eventsin, eventsout
        logical anyf
c
        coord = '-TAN'
c
c  Get an unused lun for the caldb file
c
        err = 0
        status = 0
        call ftgiou(lunin,status)
        if((status .ne. 0) .and. (err .eq. 0)) then
            err = 1
            print *, 'ESASPREP_MOSAIC POSITION 01'
            print *, 'STATUS FTGIOU =', status
        endif
c
c  Open the FITS file
c
        call ftopen (lunin,eventsin,0,blockin,status)
        if((status .ne. 0) .and. (err .eq. 0)) then
            err = 1
            print *, 'ESASPREP_MOSAIC POSITION 02'
            print *, 'STATUS FTOPEN =', status
            print *, eventsin
        endif
c
        call ftgiou(lunout,status)
        if((status .ne. 0) .and. (err .eq. 0)) then
            err = 1
            print *, 'ESASPREP_MOSAIC POSITION 03'
            print *, 'STATUS FTGIOU =', status
        endif
c
c  Initialize the output FITS file
c
        print *, 'Output file name: ', eventsout
        call ftopen (lunout,eventsout,0,block,status)
        if(status .eq. 0) then
            print *, 'Existing file name conflict'
            if(clobber .eq. 0) then
                print *, 'Will not clobber the file'
                stop
            else
                print *, 'Clobber the file and continue'
                call ftdelt(lunout,status)
            endif
        endif
        status = 0
c
c  Initialize the output file
c
        call ftinit (lunout,eventsout,blockin,status)
c
c  Copy the old file to the new file
c
        call ftcpfl (lunin,lunout,1,1,1,status)
        call ftclos(lunout,status)
        call ftopen (lunout,eventsout,1,blockin,status)
        if((status .ne. 0) .and. (err .eq. 0)) then
            err = 1
            print *, 'ESASPREP_MOSAIC POSITION 04'
            print *, 'STATUS FTOPEN =', status
            print *, eventsout
        endif
c
c  Read the FITS file header information
c
c                call ftghbn (lun,12,nchan,tfields,ttype,tform,
c     +              tunit,extname,varidat,status)
c
c  Change to reference position values in the primary header
c
        call ftgkyd (lunin,'RA_OBJ',ra,com,status)
        call ftgkyd (lunin,'DEC_OBJ',dec,com,status)
        ra = raobj
        dec = decobj
        pa = pas
        call ftgkyd (lunin,'RA_OBJ',dum,com,status)
        call ftukyd (lunout,'RA_OBJ',ra,12,com,status)
        call ftgkyd (lunin,'DEC_OBJ',dum,com,status)
        call ftukyd (lunout,'DEC_OBJ',dec,12,com,status)
        call ftgkyd (lunin,'RA_NOM',dum,com,status)
        call ftukyd (lunout,'RA_NOM',ra,12,com,status)
        call ftgkyd (lunin,'DEC_NOM',dum,com,status)
        call ftukyd (lunout,'DEC_NOM',dec,12,com,status)
        call ftgkyd (lunin,'REFXCRVL',dum,com,status)
        call ftukyd (lunout,'REFXCRVL',ra,12,com,status)
        call ftgkyd (lunin,'REFYCRVL',dum,com,status)
        call ftukyd (lunout,'REFYCRVL',dec,12,com,status)
        call ftgkyd (lunin,'RA_PNT',dum,com,status)
        call ftukyd (lunout,'RA_PNT',ra,12,com,status)
        call ftgkyd (lunin,'DEC_PNT',dum,com,status)
        call ftukyd (lunout,'DEC_PNT',dec,12,com,status)
        call ftgkyd (lunin,'PA_PNT',dum,com,status)
        call ftukyd (lunout,'PA_PNT',pa,12,com,status)
       if(status .ne. 0) then
            err = 1
            print *, 'ESASPREP_MOSAIC POSITION 05'
            print *, 'STATUS FT*KYD =', status
            print *, 'Failure on modifying ref pos'
        endif
        call ftflus(lunout,status)
c
c  Move to the correct extension
c
        if(err .eq. 0) then
            call ftmrhd (lunin,1,hdutypein,status)
            if((status .ne. 0) .and. (err .eq. 0)) then
                err = 1
                print *, 'ESASPREP_MOSAIC POSITION 06'
                print *, 'STATUS FTMRHD =', status
                print *, eventsin
                print *, 'Could not find the event list extension'
            endif
            call ftmrhd (lunout,1,hdutypeout,status)
            if((status .ne. 0) .and. (err .eq. 0)) then
                err = 1
                print *, 'ESASPREP_MOSAIC POSITION 07'
                print *, 'STATUS FTMAHD =', status
                print *, eventsout
                print *, 'Could not find the event list extension'
            else
c
c  Read the FITS file header information
c
                call ftghbn (lunin,12,nchan,tfields,ttype,tform,
     +              tunit,extname,varidat,status)
                print *, extname
                if(extname .ne. 'EVENTS') then
                    print *, 'ESASPREP_MOSAIC POSITION 08'
                    print *, extname
                    print *, 'This was supposed to be the EVENT ',
     +                      'extension'
                    stop
                endif
                if(status .ne. 0) then
                    err = 1
                    print *, 'ESASPREP_MOSAIC POSITION 09'
                    print *, 'STATUS FTGHPR =', status
                    print *, 'Failure on reading the header ',
     +                      'information'
                else
c
c  Read in the WCS information
c
c                    call ftgkyd (lunin,'RA_NOM',ra,com,status)
c                    call ftgkyd (lunin,'DEC_NOM',dec,com,status)
c                    call ftgkyd (lunin,'PA_PNT',rot,com,status)
                    call ftgkyd (lunin,'REFXCRVL',xrval,com,status)
                    call ftgkyd (lunin,'REFYCRVL',yrval,com,status)
                    call ftgkyd (lunin,'REFXCRPX',xrpix,com,status)
                    call ftgkyd (lunin,'REFYCRPX',yrpix,com,status)
                    call ftgkyd (lunin,'REFXCDLT',xinc,com,status)
                    call ftgkyd (lunin,'REFYCDLT',yinc,com,status)
c
                    if(status .ne. 0) then
                        err = 1
                        print *, 'ESASPREP_MOSAIC POSITION 10'
                        print *, 'STATUS FTGKYD =', status
                        print *, 'Failure on reading the WCS ',
     +                      'information'
                    endif
c
                    print *, 'Input File: ', eventsin
                    print *, 'Subpoint Central Coords: ', ra, dec
                    print *, 'Rotation: ', pa
                    print *, 'Project Central Coords: ', xrval, yrval
                    print *, 'Project Central Pixel: ', xrpix, yrpix
                    print *, 'Project Pixel Size: ', xinc, yinc
                    print *, 'Coordinates: ', coord
c
c Get the X,Y offsets
c
                    rot = 0
                    call ftxypx (ra,dec,xrval,yrval,xrpix,yrpix,
     +                      xinc,yinc,rot,coord,xpix,ypix,status) 
                    if(status .ne. 0) then
                        err = 1
                        print *, 'ESASPREP_MOSAIC POSITION 11'
                        print *, 'STATUS FTXYPX =', status
                        print *, 'Failure on transforming to X,Y'
                    endif
                    print *, 'Subpoint Central Pixel: ', xpix, ypix
                    dxpix = xrpix - xpix
                    dypix = yrpix - ypix
                    print *, 'Required Pixel Offset: ', dxpix, dypix
c
c  Read in the column names
c
                    call ftgkns (lunin,'TTYPE',1,10,colnam,ncols,status)
                    if(status .ne. 0) then
                        err = 1
                        print *, 'ESASPREP_MOSAIC POSITION 12'
                        print *, 'STATUS FTGKNS =', status
                        print *, 'Failure on reading the column names'
                    endif
c
c  Extract the column numbers
c
                    ix = 0
                    iy = 0
                    do icol=1,ncols
                        if(colnam(icol) .eq. 'X') ix = icol
                        if(colnam(icol) .eq. 'Y') iy = icol
                    enddo
c
c  Cycle through the events
c
                    xmin = 10000000
                    xmax = 0
                    ymin = 10000000
                    ymax = 0
                    do i=1,nchan
                        if(ix .ne. 0)
     +                      call ftgcvj(lunin,ix,i,1,1,0,
     +                          ixtin,anyf,status)
                        if(iy .ne. 0)
     +                      call ftgcvj(lunin,iy,i,1,1,0,
     +                          iytin,anyf,status)
                        x = ixtin
                        y = iytin
                        if((status .ne. 0) .and. (err .eq. 0)) then
                            err = 1
                            print *, 'ESASPREP_MOSAIC POSITION 13'
                            print *, 'STATUS FTGCVJ =', status
                            print *, 'Failure on reading data'
                        endif
c
c  Transform the coords
c
                        call ftwldp(x,y,xrval,yrval,xrpix,yrpix,
     +                      xinc,yinc,rot,coord,rat,dect,status)
                        if((status .ne. 0) .and. (err .eq. 0)) then
                            err = 1
                            print *, 'ESASPREP_MOSAIC POSITION 14'
                            print *, 'STATUS FTWLDP =', status
                            print *, 'Failure on transformation'
                        endif
                        call ftxypx (rat,dect,ra,dec,xrpix,yrpix,
     +                      xinc,yinc,rot,coord,xpix,ypix,status) 
                        if((status .ne. 0) .and. (err .eq. 0)) then
                            err = 1
                            print *, 'ESASPREP_MOSAIC POSITION 15'
                            print *, 'STATUS FTXYPX =', status
                            print *, 'Failure on transformation'
                        endif
                        ixtout = xpix
                        iytout = ypix
                        if(xpix .lt. xmin) xmin = xpix
                        if(xpix .gt. xmax) xmax = xpix
                        if(ypix .lt. ymin) ymin = ypix
                        if(ypix .gt. ymax) ymax = ypix
 2000                   format(6I8)
c                        if (i .eq. 2630) stop
c
c  Write the transformed values into the table
c
                        call ftpclj(lunout,ix,i,1,1,ixtout,status)
                        call ftpclj(lunout,iy,i,1,1,iytout,status)
                        if((status .ne. 0) .and. (err .eq. 0)) then
                            err = 1
                            print *, 'ESASPREP_MOSAIC POSITION 16'
                            print *, 'STATUS FTPCLJ =', status
                            print *, 'Failure on modifying data'
                        endif
                    enddo
c
c  Change to reference position values
c
                    call ftgkyd (lunout,'RA_OBJ',dum,com,status)
                    call ftukyd (lunout,'RA_OBJ',ra,12,com,status)
                    call ftgkyd (lunout,'DEC_OBJ',dum,com,status)
                    call ftukyd (lunout,'DEC_OBJ',dec,12,com,status)
                    call ftgkyd (lunout,'RA_NOM',dum,com,status)
                    call ftukyd (lunout,'RA_NOM',ra,12,com,status)
                    call ftgkyd (lunout,'DEC_NOM',dum,com,status)
                    call ftukyd (lunout,'DEC_NOM',dec,12,com,status)
                    call ftgkyd (lunout,'REFXCRVL',dum,com,status)
                    call ftukyd (lunout,'REFXCRVL',ra,12,com,status)
                    call ftgkyd (lunout,'REFYCRVL',dum,com,status)
                    call ftukyd (lunout,'REFYCRVL',dec,12,com,status)
                    call ftgkyd (lunout,'RA_PNT',dum,com,status)
                    call ftukyd (lunout,'RA_PNT',ra,12,com,status)
                    call ftgkyd (lunout,'DEC_PNT',dum,com,status)
                    call ftukyd (lunout,'DEC_PNT',dec,12,com,status)
                    call ftgkyd (lunout,'PA_PNT',dum,com,status)
                    call ftukyd (lunout,'PA_PNT',pa,12,com,status)
                    call ftgkyd (lunout,'TCRVL6',dum,com,status)
                    call ftukyd (lunout,'TCRVL6',ra,12,com,status)
                    call ftgkyd (lunout,'TCRVL7',dum,com,status)
                    call ftukyd (lunout,'TCRVL7',dec,12,com,status)

                    ixmin = xmin + 0.5
                    ixmax = xmax + 0.5
                    iymin = ymin + 0.5
                    iymax = ymax + 0.5

                    call ftgkyj (lunout,'REFXDMIN',idum,com,status)
                    call ftukyj (lunout,'REFXDMIN',ixmin,com,status)
                    call ftgkyj (lunout,'REFXDMAX',idum,com,status)
                    call ftukyj (lunout,'REFXDMAX',ixmax,com,status)
                    call ftgkyj (lunout,'REFYDMIN',idum,com,status)
                    call ftukyj (lunout,'REFYDMIN',iymin,com,status)
                    call ftgkyj (lunout,'REFYDMAX',idum,com,status)
                    call ftukyj (lunout,'REFYDMAX',iymax,com,status)
                    call ftgkyj (lunout,'TDMIN6',idum,com,status)
                    call ftukyj (lunout,'TDMIN6',ixmin,com,status)
                    call ftgkyj (lunout,'TDMAX6',idum,com,status)
                    call ftukyj (lunout,'TDMAX6',ixmax,com,status)
                    call ftgkyd (lunout,'TCRVL6',dum,com,status)
                    call ftukyd (lunout,'TCRVL6',ra,12,com,status)
                    call ftgkyj (lunout,'TDMIN7',idum,com,status)
                    call ftukyj (lunout,'TDMIN7',iymin,com,status)
                    call ftgkyj (lunout,'TDMAX7',idum,com,status)
                    call ftukyj (lunout,'TDMAX7',iymax,com,status)
                    call ftgkyd (lunout,'TCRVL7',dum,com,status)
                    call ftukyd (lunout,'TCRVL7',dec,12,com,status)
c
c  Now go to the primary header
c
                    call ftmrhd (lunin,-1,hdutypein,status)
                    if((status .ne. 0) .and. (err .eq. 0)) then
                        err = 1
                        print *, 'ESASPREP_MOSAIC POSITION 17'
                        print *, 'STATUS FTMRHD =', status
                        print *, eventsin
                        print *, 'Could not find the event list ',
     +                          'extension'
                    endif
                    call ftmrhd (lunout,-1,hdutypeout,status)
                    if((status .ne. 0) .and. (err .eq. 0)) then
                        err = 1
                        print *, 'ESASPREP_MOSAIC POSITION 18'
                        print *, 'STATUS FTMAHD =', status
                        print *, eventsout
                        print *, 'Could not find the event list ',
     +                          'extension'
                    endif
                    call ftgkyj (lunout,'REFXDMIN',idum,com,status)
                    call ftukyj (lunout,'REFXDMIN',ixmin,com,status)
                    call ftgkyj (lunout,'REFXDMAX',idum,com,status)
                    call ftukyj (lunout,'REFXDMAX',ixmax,com,status)
                    call ftgkyj (lunout,'REFYDMIN',idum,com,status)
                    call ftukyj (lunout,'REFYDMIN',iymin,com,status)
                    call ftgkyj (lunout,'REFYDMAX',idum,com,status)
                    call ftukyj (lunout,'REFYDMAX',iymax,com,status)
                    if(status .ne. 0) then
                        err = 1
                        print *, 'ESASPREP_MOSAIC POSITION 19'
                        print *, 'STATUS FT*KYD =', status
                        print *, 'Failure on modifying ref pos'
                    endif
                    call ftmrhd (lunin,2,hdutypein,status)
                    if((status .ne. 0) .and. (err .eq. 0)) then
                        err = 1
                        print *, 'ESASPREP_MOSAIC POSITION 17'
                        print *, 'STATUS FTMRHD =', status
                        print *, eventsin
                        print *, 'Could not find the event list ',
     +                          'extension'
                    endif
                    call ftmrhd (lunout,2,hdutypeout,status)
                    if((status .ne. 0) .and. (err .eq. 0)) then
                        err = 1
                        print *, 'ESASPREP_MOSAIC POSITION 18'
                        print *, 'STATUS FTMAHD =', status
                        print *, eventsout
                        print *, 'Could not find the event list ',
     +                          'extension'
                    endif
                    call ftgkyd (lunin,'RA_OBJ',ra,com,status)
                    call ftgkyd (lunin,'DEC_OBJ',dec,com,status)
                    call ftgkyd (lunin,'REFXCRVL',dum,com,status)
                    call ftukyd (lunout,'REFXCRVL',ra,12,com,status)
                    call ftgkyd (lunin,'REFYCRVL',dum,com,status)
                    call ftukyd (lunout,'REFYCRVL',dec,12,com,status)
                    call ftgkyd (lunin,'RA_PNT',dum,com,status)
                    call ftukyd (lunout,'RA_PNT',ra,12,com,status)
                    call ftgkyd (lunin,'DEC_PNT',dum,com,status)
                    call ftukyd (lunout,'DEC_PNT',dec,12,com,status)
                    call ftgkyd (lunin,'PA_PNT',dum,com,status)
                    call ftukyd (lunout,'PA_PNT',pa,12,com,status)
                    call ftgkyj (lunout,'REFXDMIN',idum,com,status)
                    call ftukyj (lunout,'REFXDMIN',ixmin,com,status)
                    call ftgkyj (lunout,'REFXDMAX',idum,com,status)
                    call ftukyj (lunout,'REFXDMAX',ixmax,com,status)
                    call ftgkyj (lunout,'REFYDMIN',idum,com,status)
                    call ftukyj (lunout,'REFYDMIN',iymin,com,status)
                    call ftgkyj (lunout,'REFYDMAX',idum,com,status)
                    call ftukyj (lunout,'REFYDMAX',iymax,com,status)
                    if(status .ne. 0) then
                        err = 1
                        print *, 'ESASPREP_MOSAIC POSITION 19'
                        print *, 'STATUS FT*KYD =', status
                        print *, 'Failure on modifying ref pos'
                    endif
c
c  Write out the updated event file
c
c                    call ftflus(lunout,status)
                    call ftclos (lunin,status)
                    call ftclos (lunout,status)
                endif
            endif
        endif
c
        return
        end


