!+
! Module: mos_back_mod
!
! Authors:  Steven L. Snowden - Goddard Space Flight Center (NASA)
!
! Description: Extended Source Analysis Software
!
! Comments:
!
! $Id: mos_back_mod.f90,v 1.2 2009/02/20 13:27:08 aibarra Exp $
!-
module mos_back_mod

  use dal
  use param
  use errorHandling

  implicit none

  private

  public mos_back

contains

  !---------------------------------------------------------------------
  subroutine mos_back
  !---------------------------------------------------------------------
    character (len=1024) :: prefix,xmmdir
    integer :: ccd1,ccd2,ccd3,ccd4,ccd5,ccd6,ccd7,el,eh,diag

    prefix = stringParameter("prefix")
    xmmdir = stringParameter("caldb")
    diag = intParameter("diag")
    el = intParameter("elow")
    eh = intParameter("ehigh")
    ccd1 = intParameter("ccd1")
    ccd2 = intParameter("ccd2")
    ccd3 = intParameter("ccd3")
    ccd4 = intParameter("ccd4")
    ccd5 = intParameter("ccd5")
    ccd6 = intParameter("ccd6")
    ccd7 = intParameter("ccd7")

    call mos_back_sub(prefix,xmmdir,xmmdir,diag,el,eh,ccd1,ccd2,ccd3,ccd4,ccd5,ccd6,ccd7)


  end subroutine mos_back

end module mos_back_mod
