!+
! Module: pn_back_mod
!
! Authors:  Steven L. Snowden - Goddard Space Flight Center (NASA)
!
! Description: Extended Source Analysis Software
!
! Comments:
!
! $Id: pn_back_mod.f90,v 1.1 2009/02/06 14:10:35 aibarra Exp $
!-
module pn_back_mod

  use dal
  use param
  use errorHandling

  implicit none

  private

  public pn_back

contains

  !---------------------------------------------------------------------
  subroutine pn_back
  !---------------------------------------------------------------------
    character (len=1024) :: prefix,xmmdir
    integer :: quad1,quad2,quad3,quad4,el,eh,diag

    prefix = stringParameter("prefix")
    xmmdir = stringParameter("caldb")
    diag = intParameter("diag")
    el = intParameter("elow")
    eh = intParameter("ehigh")
    quad1 = intParameter("quad1")
    quad2 = intParameter("quad2")
    quad3 = intParameter("quad3")
    quad4 = intParameter("quad4")

    call pn_back_sub(prefix,xmmdir,xmmdir,diag,el,eh,quad1,quad2,quad3,quad4)

  end subroutine pn_back

end module pn_back_mod
