!+
! Module: point_source_mod
!
! Authors:  Steven L. Snowden - Goddard Space Flight Center (NASA)
!
! Description: Extended Source Analysis Software
!
! Comments:
!
! $Id: point_source_mod.f90,v 1.1 2009/02/06 14:10:35 aibarra Exp $
!-
module point_source_mod

  use dal
  use param
  use errorHandling

  implicit none

  private

  public point_source

contains

  !---------------------------------------------------------------------
  subroutine point_source
  !---------------------------------------------------------------------
    character (len=1024) :: func
    real :: min_src_flux, cxrb_norm, index

    func = stringParameter("func")
    min_src_flux = realParameter("min_src_flux")
    cxrb_norm = realParameter("cxrb_norm")
    index = realParameter("index")


    call point_source_sub(func,min_src_flux,cxrb_norm,index)

  end subroutine point_source

end module point_source_mod
