!+
! Module: swcx_mod
!
! SAS Version 12.0
! Version 1.1
!
! Authors:  Steven L. Snowden - Goddard Space Flight Center (NASA)
!
! Description: Extended Source Analysis Software
!
! Comments:
!
! $Id: swcx_mod.f90,v 1.0 2010/06/24 16:39:45 Snowden $
!-
module swcx_mod

  use dal
  use param
  use errorHandling

  implicit none

  private

  public swcx

contains

  !---------------------------------------------------------------------
  subroutine swcx
  !---------------------------------------------------------------------
    real, dimension(:), allocatable :: gnormlist
    real, dimension(:), allocatable :: linelist
    character (len=1024) :: obj_arf, obj_rmf, obj_spec, prefix, xmmdir
    integer :: ccd1,ccd2,ccd3,ccd4,ccd5,ccd6,ccd7,elow,ehigh,i,nlines

    prefix = stringParameter("prefix")
    xmmdir = stringParameter("caldb")
    ccd1 = intParameter("ccd1")
    ccd2 = intParameter("ccd2")
    ccd3 = intParameter("ccd3")
    ccd4 = intParameter("ccd4")
    ccd5 = intParameter("ccd5")
    ccd6 = intParameter("ccd6")
    ccd7 = intParameter("ccd7")
    elow = intParameter("elow")
    ehigh = intParameter("ehigh")
    obj_rmf = stringParameter("objrmf")
    obj_arf = stringParameter("objarf")
    obj_spec = stringParameter("objspec")

    nlines = parameterCount("linelist")
    allocate(linelist(nlines))
    allocate(gnormlist(nlines))
    do i=1, nlines
      linelist(i) = realParameter("linelist",i-1)
      gnormlist(i) = realParameter("gnormlist",i-1)
    end do

    call swcx_sub(prefix,xmmdir,xmmdir,ccd1,ccd2,ccd3,ccd4,ccd5,ccd6,ccd7,elow,ehigh,nlines,linelist,gnormlist,obj_rmf,obj_arf,obj_spec)


  end subroutine swcx

end module swcx_mod
